#!/usr/bin/perl

#┌─────────────────────────────────
#│ CLIP BOARD : admin.cgi - 2019/12/01
#│ copyright (c) kentweb, 1997-2019
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  ClipBoard v6.0 : - 2019/12/06
#│  Edited by Hamel(TRANSFORM) Since 2012
#│  http://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;

# 設定ファイル認識
require "./init.cgi";
my %cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
cgi_err('容量オーバー') if ($cgi->truncated);
my %in = parse_form($cgi);

# 認証
check_passwd();

# 条件分岐
if ($in{mente_log}) { mente_log(); }
if ($in{mente_res}) { mente_res(); }
if ($in{apprv_log}) { apprv_log(); }

# 管理モード
menu_html();

#-----------------------------------------------------------
#  メニュー画面
#-----------------------------------------------------------
sub menu_html {
	header("メニューTOP");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} 管理画面 ::</b>
	</div>
</div>
<div id="main">
<div id="main-in">
<div class="center">
<p>選択ボタンを押してください。</p>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">
<table class="deco">
<tr>
	<th>選択</th>
	<th width="300">処理メニュー</th>
</tr><tr>
	<td><input type="submit" name="mente_log" class="color cerulean-blue  button" value="選択""></td>
	<td>&nbsp; 記事メンテナンス（修正/削除）</td>
EOM

	if ($cf{approve} == 1) {
		print qq|</tr><tr>\n|;
		print qq|<td class="ta-c"><input type="submit" name="apprv_log" class="color cerulean-blue button" value="選択"></td>\n|;
		print qq|<td class="ta-l">&nbsp; コメントの承認/反映</td>\n|;
	}

	if ($cf{comment}) {
		print qq|</tr><tr>\n|;
		print qq|<td><input type="submit" name="mente_res" class="color cerulean-blue button" value="選択"></td>\n|;
		print qq|<td>&nbsp; コメント返信の削除</td>\n|;
	}

	print <<EOM;
</tr><tr>
	<td><input type="button" class="color cerulean-blue button" value="選択" onclick="javascript:window.location='$cf{bbs_cgi}'"></td>
	<td>&nbsp; 掲示板へ戻る</td>
</tr><tr>
	<td><input type="button" class="color cerulean-blue button" value="選択" onclick="javascript:window.location='$cf{admin_cgi}'""></td>
	<td>&nbsp; ログアウト</td>
</tr>
</table>
</form>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  記事メンテナンス
#-----------------------------------------------------------
sub mente_log {
	# 編集フォーム
	if ($in{mode_edit} && $in{no}) {
		my $log;
		open(DAT,"$cf{logfile}") or cgi_err("open err: $cf{logfile}");
		while (<DAT>) {
			my ($no) = (split(/<>/))[0];

			if ($in{no} == $no) {
				$log = $_;
				last;
			}
		}
		close(DAT);

		# フォーム
		edit_form($log);

	# 編集実行
	} elsif ($in{mode_edit2} && $in{no}) {

		if ($in{url} eq 'http://') { $in{url} = ''; }

		my (@log,$ext2,$w2,$h2);
		open(DAT,"+< $cf{logfile}") or cgi_err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$ex,$w,$h,$tim,$chk,$col,$color2) = split(/<>/);

			if ($in{no} == $no) {

				# アップロード
				if ($in{upfile}) { ($ext2,$w2,$h2) = upload($in{no}); }

				# 添付削除
				if ($in{del}) {
					unlink("$cf{imgdir}/$no$ex");
					unlink("$cf{imgdir}/$no-s$ex") if (-f "$cf{imgdir}/$no-s$ex");
					$ex = $w = $h = '';
				}

				# 添付アップロードの場合
				if ($ext2) {
					# 拡張子変更の場合旧ファイル削除
					if ($ex && $ext2 ne $ex) {
						unlink("$cf{imgdir}/$in{no}$ex");
						unlink("$cf{imgdir}/$in{no}-s$ex") if (-f "$cf{imgdir}/$in{no}-s$ex");
					}
					# 新添付ファイル情報
					($ex,$w,$h) = ($ext2,$w2,$h2);
				}

				$_ = "$no<>$dat<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$hos<>$pw<>$ex<>$w<>$h<>$tim<>$chk<>$in{color}<>$in{color2}<>\n";
			}
			push(@log,$_);
		}
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		msg_edit("修正が完了しました");

	# 画像許可
	} elsif ($in{mode_chk} && $in{no}) {
		my %chk;
		foreach ( $cgi->param('no') ) {
			$chk{$_}++;
		}

		# 削除情報をマッチング
		my @log;
		open(DAT,"+< $cf{logfile}") or cgi_err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$ex,$w,$h,$tim,$chk,$col,$color2) = split(/<>/);

			if (defined($chk{$no})) {
				if ($chk == 1) { $chk = 0; } else { $chk = 1; }
				$_ = "$no<>$dat<>$nam<>$eml<>$sub<>$com<>$url<>$hos<>$pw<>$ex<>$w<>$h<>$tim<>$chk<>$col<>$color2<>\n";
			}
			push(@log,$_);
		}
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 削除処理
	} elsif ($in{mode_del} && $in{no}) {
		my %del;
		foreach ( $cgi->param('no') ) {
			$del{$_}++;
		}

		# 削除情報をマッチング
		my @log;
		open(DAT,"+< $cf{logfile}") or cgi_err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$ex,$w,$h,$tim,$chk,$col,$color2) = split(/<>/);

			if (defined($del{$no})) {
				unlink("$cf{imgdir}/$no$ex") if ($ex);
				unlink("$cf{imgdir}/$no-s$ex") if (-f "$cf{imgdir}/$no-s$ex");
				next;
			}
			push(@log,$_);
		}
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 返信ログから関連レスを削除
		# 返信ログオープン
		my $res = 0;
		my @data;
		open(DAT,"+< $cf{reslog}");
		eval "flock(DAT, 2);";
		while (<DAT>) {

			my ($no,$ent,$date,$name,$eml,$url,$com,$ex,$w,$h,$chk) = split(/<>/);

			if ($in{no} == $ent) { $res++; }
			if (defined($del{$ent})) {

				# 画像削除
				if ($ex) { unlink("$cf{r_upldir}/$no$ex"); }
				next;
			}
			push(@data,$_);
		}

			# 採番
			open(DAT,"+< $cf{resnum}");
			eval "flock(DAT, 2);";
			my $num = <DAT> - $res;
			seek(DAT, 0, 0);
			print DAT $num;
			truncate(DAT, tell(DAT));
			close(DAT);

		# 返信ログ更新
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 親記事用レスカウント更新
	top_rescnt();

	}

	# 画面表示
	header("管理メニュー &gt; 記事メンテナンス（修正/削除）");
	back_btn('mente_log');
	print <<"EOM";
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} 管理画面 ::</b>
	</div>
</div>
<div id="main">
<div id="main-in">
<div class="sub-ttl"> 記事メンテナンス（修正/削除）</div>
<br />
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="mente_log" value="1">
<input type="hidden" name="pass" value="$in{pass}">
<input type="submit" name="mode_edit" class="color cerulean-blue large button" value="修正する">
<input type="submit" name="mode_del" class="color cerulean-blue large button" value="削除する">
EOM

	if ($cf{imgcheck}) {
		print qq|<input type="submit" name="mode_chk" value="添付許可">\n|;
	}

	open(IN,"$cf{logfile}") or cgi_err("open err: $cf{logfile}");
	while (<IN>) {
		my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$ex,$w,$h,$tim,$chk,$col,$color2) = split(/<>/);
		if ($eml) { $nam = qq|<a href="mailto:$eml">$nam</a>|; }
		my @col = split(/\s+/, $cf{colors});
		$com = auto_link($com) if ($cf{autolink});

		# YouTube
		if ($cf{tube}) {
			$com =~ s|!([\w\-]{1,})!|<a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="tube"></a>|g;
		}

		print qq|<div class="art" style="border-color:$color2"><input type="radio" name="no" value="$no">|;
		print qq|[$no] <strong>$sub</strong> 投稿者：<b style="color:$color2">$nam</b> 投稿日：<span style="color:green">$dat</span> &lt;<span style="color:#FF6699">$hos</span>&gt;\n|;
		#print qq|<div class="com">| . cut_str($com) . qq|</div>\n|;
		print qq|<br><br><span style="color:$col[$col]">$com</span>\n|;
		if ($ex) {
			my $size = get_size("$cf{imgdir}/$no$ex");
			print qq|<div class="ext"><br>添付|;
			if ($cf{imgcheck}) {
				if ($chk == 1) { print "[○]"; } else { print "[×]"; }
			}
			print qq|：<a href="$cf{imgurl}/$no$ex" target="_blank">$no$ex</a> ($size)</div>\n|;
		}
		print qq|</div>\n|;
	}
	close(IN);

		print qq|<div class="art-end"></div></form>\n|;
		print qq|</div></body></html>\n|;

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  編集フォーム
#-----------------------------------------------------------
sub edit_form {
	my $log = shift;
	my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$ex,$w,$h,$tim,$chk,$col,$color2) = split(/<>/, $log);
	$com =~ s|<br( /)?>|\n|g;
	$url ||= 'http://';

	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($col == $_) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]">■</span>\n|;
	}
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	#if ($color2 eq "") { $color2 = $col3[0]; }
	foreach (0 .. $#col3) {
		if ($col3[$_] eq $color2) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	my $clip;
	if ($ex) {
		$clip .= qq|[<a href="$cf{imgurl}/$no$ex" target="_blank">添付</a>]\n|;
		$clip .= qq|<input type="checkbox" name="del" value="1">削除\n|;
	}

	header('管理TOP &gt; 編集フォーム');
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} 管理画面 ::</b>
	</div>
</div>
<div id="main">
<div id="main-in">
<div class="sub-ttl"> 管理TOP &gt; 編集フォーム</div>
<br />
<div align="right">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">
<input type="submit" class="color cerulean-blue large button" value="&lt; 前に戻る">
</form>
</div>
<form action="$cf{admin_cgi}" method="post" enctype="multipart/form-data">
<input type="hidden" name="pass" value="$in{pass}">
<input type="hidden" name="mente_log" value="1">
<input type="hidden" name="mode_edit2" value="1">
<input type="hidden" name="no" value="$in{no}">
<table class="regfm">
<tr>
	<th>なまえ</th>
	<td><input type="text" name="name" size="30" class="reg-name" value="$nam" style="color:gray; border-width:1px; border-color:rgb(233,84,100); border-style:dotted;"></td>
</tr><tr>
	<th>E-mail</th>
	<td><input type="text" name="email" size="30" class="reg-name" value="$eml" style="color:gray; border-width:1px; border-color:rgb(233,84,100); border-style:dotted;"></td>
</tr><tr>
	<th>タイトル</th>
	<td><input type="text" name="sub" size="36" class="reg-name" value="$sub" style="color:gray; border-width:1px; border-color:rgb(233,84,100); border-style:dotted;"></td>
</tr><tr>
	<th>コメント</th>
	<td>
	<a href="$cf{bbs_cgi}?mode=expound" onclick="window.open(this.href,'expound','width=1250,height=450,scrollbars=1');return false;">【YouTube貼\付方法】</a>←クリック<br />
	<textarea name="comment" class="reg-com" rows="7" style="color:gray; border-width:1px; border-color:rgb(233,84,100); border-style:dotted;">$com</textarea>
	</td>
</tr><tr>
	<th>参照先</th>
	<td><input type="text" name="url" size="55" class="reg-url" value="$url" style="color:gray; border-width:1px; border-color:rgb(233,84,100); border-style:dotted;"></td>
</tr><tr>
	<th>枠色</th>
	<td>
		<select name="color2">
		$color_b
		</select>
	</td>
</tr><tr>
	<th>文字色</th>
	<td>$color</td>
</tr><tr>
	<th>添付</th>
	<td>
	<input type="file" name="upfile" size="36" /> 
		$clip
	</td>
</tr>
</table>
<br>
<input type="submit" class="reg-btn" value="編集する">
</form>
<hr class="bottom /">
</body>
</html>
EOM

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  コメント返信の承認・反映
#-----------------------------------------------------------
sub apprv_log {
	# 承認
	if ($in{job} eq 'aprv' && $in{no}) {

		my @data;
		foreach ( split(/\0/, $in{no}) ) {
			open(IN,"$cf{logdir}/$_.cgi");
			my $log = <IN>;
			close(IN);

			push(@data,$log);
		}

	# 連番読み込み
	open(DAT,"+< $cf{resnum}");
	eval "flock(DAT, 2);";
	my $number = <DAT>;
	seek(DAT, 0, 0);
	print DAT $number;
	truncate(DAT, tell(DAT));
	close(DAT);

		my @log;
		open(DAT,"+< $cf{reslog}") or cgi_err("open err: $cf{reslog}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($no,$ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/);
				push(@log,$_);
		}

		foreach (@data) {
			unshift(@log,"$number<>$_\n");
		}

		# 更新
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);

	# TOPレスカウント更新
	top_rescnt();

		# 一時ファイル削除
		foreach ( split(/\0/,$in{no}) ) {
			unlink("$cf{logdir}/$_.cgi");
		}

	# 削除
	} elsif ($in{job} eq 'dele' && $in{no}) {
		foreach ( split(/\0/,$in{no}) ) {
			unlink("$cf{logdir}/$_.cgi");
		}
	}

	# クッキー格納
	set_cookie($in{name},$in{url}) if ($in{cookie});

	# コメント返信の承認/反映画面を表示
	header("コメント返信の承認/反映");
	back_btn('apprv_log');
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} 管理画面 ::</b>
	</div>
</div>
<div id="main">
<div id="main-in">
<div class="sub-ttl"> コメント返信の承認/反映</div>
<ul>
<li>「承認」又は「削除」を選択して送信ボタンを押してください。やり直しはできないので慎重に！
</ul>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="apprv_log" value="1">
<input type="hidden" name="pass" value="$in{pass}">
処理：
<select name="job">
<option value="aprv">承認
<option value="dele">削除
</select>
<input type="submit" value="送信する">
EOM

	opendir(DIR,"$cf{logdir}");
	while( $_ = readdir(DIR) ) {
		next if (!/^(\d+)\.cgi$/);

		my $num = $1;
		open(IN,"$cf{logdir}/$num.cgi");
		my $log = <IN>;
		close(IN);

		my ($ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/,$log);
		print qq|<div class="art"><input type="checkbox" name="no" value="$num">\n|;
		print qq|<strong>$sub</strong> 投稿者：<b>$name</b> 投稿日：$date [ <span>$host</span> ]\n|;
		print qq|<div class="com">$com</div>\n|;
		if ($ex) {
			my $size = get_size("$cf{r_upldir}/$num$ex");
			print qq|<dd>添付|;
			if ($cf{imgcheck}) {
				if ($chk == 1) { print "[<span class=\"grn\">承認済</span>]"; } else { print "[<span class=\"red\">未承認</span>]"; }
			}
			print qq|：<a href="$cf{r_uplurl}/$num$ex" target="_blank">$num$ex</a> ($size)</div>\n|;
		}
	}
	closedir(DIR);

	print <<EOM;
</form>
<hr class="bottom">
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-------------------------------------------------
#  コメント返信メンテナンス
#-------------------------------------------------
sub mente_res {

	# ページ数
	my $page = $in{page} || '0';
	foreach ( $cgi->param() ) {
		if (/^page:(\d+)$/) {
			$page = $1;
			last;
		}
	}

	# 削除処理
	if ($in{'no'}) {

		# 削除情報
		my %del;
		foreach ( split(/\0/, $in{'no'}) ) {
			$del{$_} = 1;
		}

		# 返信ログオープン
		my @data;
		open(DAT,"+< $cf{reslog}");
		eval "flock(DAT, 2);";
		while (<DAT>) {

			my ($no,$ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/);

			if (defined($del{$no})) {

				# 画像削除
				if ($ex) { unlink("$cf{r_upldir}/$no$ex"); }

				next;
			}

			push(@data,$_);
		}

		# 返信ログ更新
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 採番
	open(DAT,"+< $cf{resnum}");
	eval "flock(DAT, 2);";
	my $num = <DAT> - 1;
	seek(DAT, 0, 0);
	print DAT $num;
	truncate(DAT, tell(DAT));
	close(DAT);

	# TOP用レスカウント更新
	top_rescnt();

	}

	header("管理メニュー &gt; コメント返信の削除");
	back_btn('mente_res');
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} 管理画面 ::</b>
	</div>
</div>
<div id="main">
<div id="main-in">
<div class="sub-ttl"> コメント返信の削除</div>
<blockquote>
・削除するコメントを選択し、削除ボタンを押してください。
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">
<input type="hidden" name="mente_res" value="1">
<input type="submit" class="color cerulean-blue large button" value="削除する"">
</blockquote>
<div class="center">
<table class="edit-fm">
<tr>
  <th>選択</th>
  <th>[No.] 返信投稿日時</th>
  <th>親記事タイトル(投稿日)</th>
  <th>返信投稿者</th>
  <th class="mobile">コメント</th>
  <th class="mobile">添付</th>
</tr>
EOM

	# 記事
	my %sub;
	open(IN,"$cf{logfile}");
	while (<IN>) {
		my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$ex,$w,$h,$tim,$chk,$color,$color2) = split(/<>/);
			$sub{$no} = "<b style=\"color:#ed6d46\">$sub</b> (<span style=\"color:#a688bd\">$dat</span>)";
	}
	close(IN);

	# コメント返信
	my $i = 0;
	open(IN,"$cf{reslog}");
	while(<IN>) {
		$i++;
		my ($num,$ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/);

		next if ($i < $page + 1);
		next if ($i > $page + $cf{pg_max});

		$com =~ s/<[^>]*(>|$)//g;
		if (length($com) > 45) {
			$com = substr($com,0,45) . ' <span style="color:#941f57">.......(略)</span>';
		}

		print qq |<tr><td width="60px"><input type="checkbox" name="no" value="$num"></td>|;
		print qq |<td width="260px">[$num] <soan style="color:green">$date</span></td>|;
		print qq |<td width="450px">$sub{$ent}</td>|;
		print qq |<td width="95px">$name</td>|;
		print qq |<td width="340px "class="mobile"><div class="com">$com</div></td>|;

		if ($ex) {
			my $size = get_size("$cf{r_upldir}/$num$ex");
			if ($cf{imgcheck}) {
				if ($chk == 1) { print "[○]"; } else { print "[×]"; }
			}
			print qq |<td width="180px"class="mobile"><div class="ext">添付:|;
			print qq |<a href="$cf{r_uplurl}/$num$ex" target="_blank">$num$ex</a> ($size)</div></div></td></tr>\n|;
		} else {
			print qq |<td width="180px""class="mobile"><div class="ext">添付なし</div></div></td></tr>\n|;
		}
	}
	close(IN);

	if ($i == 0) {
		print qq |<td align="center" colspan="5"><font size="-1">コメント返信がありません</font></td>|;
	}

	my $next = $page + $cf{pg_max};
	my $back = $page - $cf{pg_max};

	if ($back >= 0) {
		print qq|<input type="submit" name="page:$back" value="前画面" style="color:rgb(38,38,38); background-color:rgb(255,197,86); border-width:1px; border-top-color:rgb(255,232,188); border-right-color:rgb(255,153,102); border-bottom-color:rgb(255,153,102); border-left-color:rgb(255,232,188); border-style:solid;"><br><br>\n|;
	}
	if ($next < $i) {
		print qq|<input type="submit" name="page:$next" value="次画面" style="color:rgb(38,38,38); background-color:rgb(255,197,86); border-width:1px; border-top-color:rgb(255,232,188); border-right-color:rgb(255,153,102); border-bottom-color:rgb(255,153,102); border-left-color:rgb(255,232,188); border-style:solid;"><br><br>\n|;
	}

	print <<EOM;
</div>
</table>
</form>
<hr class="bottom">
</body></html>
EOM
	exit;
}

#-------------------------------------------------
#  TOP用レスカウント更新
#-------------------------------------------------
sub top_rescnt {

	# コメントログ
	my (%res, @data);
	open(DB,"$cf{reslog}");
	while( my $db = <DB> ) {
		my ($no,$ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/, $db);
		$res{$ent}++;
	}
	close(DB);

	# 記事ログ
	open(DB,"$cf{logfile}");
	while( my $db = <DB> ) {
		chomp($db);
		my ($no,$date,$name) = split(/<>/, $db);

		if (!defined($res{$no})) { $res{$no} = 0; }
		push(@data,"$no<>$date<>$name<>$res{$no}<>\n");

	}
	close(DB);

	# index更新
	open(DAT,"+< $cf{rescnt}");
	eval "flock(DAT, 2);";
	seek(DAT, 0, 0);
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);
}

#-----------------------------------------------------------
#  添付アップロード
#-----------------------------------------------------------
sub upload {
	my $num = shift;

	# サムネイル機能
	require './lib/thumb.pl' if ($cf{thumbnail});

	# 拡張子取得
	my $ex = $cgi->param_filename('upfile') =~ /(\.[^\\\/:\.]+)$/ ? $1 : error("拡張子不明");
	$ex =~ tr/A-Z/a-z/;
	if ($ex eq '.jpeg') { $ex = '.jpg'; }

	# ファイルチェック
	check_upl($ex);

	# 添付ファイル定義
	my $upfile = "$cf{imgdir}/$num$ex";

	# アップロード書き込み
	my $buf;
	open(UP,"+> $upfile") or error("up err: $upfile");
	binmode(UP);
	print UP $in{upfile};
	close(UP);

	# パーミッション付与
	chmod(0666,$upfile);

	# 画像サイズ取得
	my ($flg,$w,$h);
	if ($ex eq ".jpg") { ($w,$h) = j_size($upfile); $flg++; }
	elsif ($ex eq ".gif") { ($w,$h) = g_size($upfile); $flg++; }
	elsif ($ex eq ".png") { ($w,$h) = p_size($upfile); $flg++; }

	# サムネイル化
	if ($flg && $cf{thumbnail}) {
		($w,$h) = resize($w,$h);
		my $thumb = "$cf{imgdir}/$num-s$ex";
		make_thumb($upfile,$thumb,$w,$h);
	}

	# 結果を返す
	return ($ex,$w,$h);
}

#-----------------------------------------------------------
#  JPEGサイズ認識
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;

	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);

	return ($w, $h);
}

#-----------------------------------------------------------
#  GIFサイズ認識
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;

	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);

	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));

	return ($w, $h);
}

#-----------------------------------------------------------
#  PNGサイズ認識
#-----------------------------------------------------------
sub p_size {
	my $png = shift;

	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);

	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));

	return ($w, $h);
}

#-----------------------------------------------------------
#  ファイルチェック
#-----------------------------------------------------------
sub check_upl {
	my ($ext) = @_;

	# mimeタイプ
	my $mime = $cgi->param_mime('upfile');

	my $flg;
	if ($cf{ok_gif}) {
		if ($mime =~ /^image\/gif$/i and $ext eq '.gif') { $flg++; }
	}
	if (!$flg and $cf{ok_jpeg}) {
		if ($mime =~ /^image\/p?jpe?g$/i and $ext eq '.jpg') { $flg++; }
	}
	if (!$flg and $cf{ok_png}) {
		if ($mime =~ /^image\/(x-)?png$/i and $ext eq '.png') { $flg++; }
	}
	if (!$flg and $cf{ok_pdf}) {
		if ($mime =~ /^application\/pdf$/i and $ext eq '.pdf') { $flg++; }
	}
	if (!$flg and $cf{ok_zip}) {
		if ($mime =~ /^application\/(x-)?zip(-compressed)?$/i and $ext eq '.zip') { $flg++; }
	}
	if (!$flg and $cf{ok_text}) {
		if ($mime =~ /^text\/plain$/i and $ext =~ /^\.te?xt$/) { $flg++; }
	}
	if (!$flg and $cf{ok_word}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?word$/i and $ext eq '.doc') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.wordprocessingml\.document$/i and $ext eq '.docx') { $flg++; }
	}
	if (!$flg and $cf{ok_excel}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?excel$/i and $ext eq '.xls') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.spreadsheetml\.sheet$/i and $ext eq '.xlsx') { $flg++; }
	}
	if (!$flg and $cf{ok_ppt}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?powerpoint$/i and $ext eq '.ppt') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.presentationml\.presentation$/i and $ext eq '.pptx') { $flg++; }
	}
	if (!$flg and $cf{ok_mp3}) {
		if ($mime =~ /^audio\/mpeg$/i and $ext eq '.mp3') { $flg++; }
		elsif ($mime =~ /^audio\/mp3/i and $ext eq '.mp3') { $flg++; }
		elsif ($mime =~ /^audio\/mpg/i and $ext eq '.mp3') { $flg++; }
	}
	if (!$flg and $cf{ok_mp4}) {
		if ($mime =~ /^video\/mpeg$/i and $ext eq '.mp4') { $flg++; }
		elsif ($mime =~ /^video\/mp4/i and $ext eq '.mp4') { $flg++; }
		elsif ($mime =~ /^video\/mpg/i and $ext eq '.mp4') { $flg++; }
	}

	if (!$flg) { error('このファイルは取り扱いできません'); }
}

#-----------------------------------------------------------
#  クッキー発行
#-----------------------------------------------------------
sub set_cookie {
	my @data = @_;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# 時刻フォーマット
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

	# URLエンコード
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	print "Set-Cookie: $cf{cookie_id}=$cook; expires=$gmt\n";
}


#-----------------------------------------------------------
#  HTMLヘッダー
#-----------------------------------------------------------
sub header {
	my $ttl = shift;

	print <<EOM;
Content-type: text/html; charset=utf-8

<!doctype html>
<html lang="ja">
<head>
<meta charset="UTF-8">
<meta http-equiv="content-style-type" content="text/css" />
<meta name="viewport" content="width=device-width,initial-scale=1.0,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no">
<script type="text/javascript"> 
var ua = navigator.userAgent;
if(ua.indexOf('iPhone') != -1 || ua.indexOf('Android') != -1){
//iPhone & Android
document.write('<link rel="stylesheet" href="cmn/admin-mobile.css">');
}else{
//PC
document.write('<link rel="stylesheet" href="cmn/admin.css">');
}
</script>
	<!-- Add jQuery library -->
	<script type="text/javascript" src="fancyBox/lib/jquery-1.10.1.min.js"></script>

	<!-- Add mousewheel plugin (this is optional) -->
	<script type="text/javascript" src="fancyBox/lib/jquery.mousewheel-3.0.6.pack.js"></script>

	<!-- Add fancyBox main JS and CSS files -->
	<script type="text/javascript" src="fancyBox/source/jquery.fancybox.js?v=2.1.5"></script>
	<link rel="stylesheet" type="text/css" href="fancyBox/source/jquery.fancybox.css?v=2.1.5" media="screen" />

	<!-- Add Button helper (this is optional) -->
	<link rel="stylesheet" type="text/css" href="fancyBox/source/helpers/jquery.fancybox-buttons.css?v=1.0.5" />
	<script type="text/javascript" src="fancyBox/source/helpers/jquery.fancybox-buttons.js?v=1.0.5"></script>

	<!-- Add Thumbnail helper (this is optional) -->
	<link rel="stylesheet" type="text/css" href="fancyBox/source/helpers/jquery.fancybox-thumbs.css?v=1.0.7" />
	<script type="text/javascript" src="fancyBox/source/helpers/jquery.fancybox-thumbs.js?v=1.0.7"></script>

	<!-- Add Media helper (this is optional) -->
	<script type="text/javascript" src="fancyBox/source/helpers/jquery.fancybox-media.js?v=1.0.6"></script>
<script type="text/javascript" src="fancyBox/source/fancybox.js"></script>
<title>$ttl</title>
</head>
<body>
EOM
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<p style="margin-top:2em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:11pt;">
- <a href="http://www.kent-web.com/" target="_top">$cf{version}</a> -<br>
++ <a href="http://www.transformsite.com/" target="_top">Edited by Hamel</a> ++
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  パスワード認証
#-----------------------------------------------------------
sub check_passwd {
	# パスワードが未入力の場合は入力フォーム画面
	if ($in{pass} eq "") {
		enter_form();

	# パスワード認証
	} elsif ($in{pass} ne $cf{password}) {
		cgi_err("認証できません");
	}
}

#-----------------------------------------------------------
#  入室画面
#-----------------------------------------------------------
sub enter_form {
	header("入室画面");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} 管理画面::</b>
	</div>
</div>
<div align="center">
<form id="login" action="$cf{admin_cgi}" method="post">
    <h1>ADMIN Log In</h1>
    <fieldset id="inputs"><legend>管理パスワード入力</legend>
        <input id="password" type="password" name="pass" placeholder="Password" autofocus required>
    </fieldset>
    <fieldset id="actions">
        <input type="submit" id="submit" value="Log in">
    </fieldset>
</form>
<script language="javascript">
<!--
self.document.forms[0].pass.focus();
//-->
</script>
</div>
</body>
</html>
EOM

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  修正完了メッセージ
#-----------------------------------------------------------
sub msg_edit {
	header("修正完了");
	print <<EOM;
<div id="head">
	<div id="head-in">
		<b>:: $cf{bbs_title} ::</b>
	</div>
</div>
<div class="all">
<div id="main">
<div id="main-in">
<div class="sub-ttl">■修正完了</div>
<p align="center">
<h5 align="center">修正を完了しました</h5>
<div align="center">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">
<input type="hidden" name="mente_log" value="1">
<input type="submit" value="記事メンテナンスに戻る" style="width:150px;" >
</form>
</.div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  エラー
#-----------------------------------------------------------
sub cgi_err {
	my $err = shift;

	header("ERROR!");
	print <<EOM;
<div align="center">
<hr width="350">
<h3>ERROR!</h3>
<p class="err">$err</p>
<hr width="350">
<form>
<input type="button" value="前画面に戻る" style="color:white; background-color:rgb(141,147,203); border:0" onclick="history.back()">
</form>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  自動リンク
#-----------------------------------------------------------
sub auto_link {
	my $text = shift;

	$text =~ s/(s?https?:\/\/([\w-.!~*'();\/?:\@=+\$,%#]|&amp;)+)/<a href="$1" target="_blank">$1<\/a>/g;
	return $text;
}

#-----------------------------------------------------------
#  ファイル容量
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024000 ? comma(int($size/1024000)) . 'MB' : $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  桁区切り
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

#-----------------------------------------------------------
#  件名文字カット for UTF-8
#-----------------------------------------------------------
sub cut_str {
	my ($str,$all) = @_;
	$str =~ s|<br( /)?>||g;
	
	# UTF-8定義
	my $byte1 = '[\x00-\x7f]';
	my $byte2 = '[\xC0-\xDF][\x80-\xBF]';
	my $byte3 = '[\xE0-\xEF][\x80-\xBF]{2}';
	my $byte4 = '[\xF0-\xF7][\x80-\xBF]{3}';
	
	my $i = 0;
	my $ret;
	while ($str =~ /($byte1|$byte2|$byte3|$byte4)/gx) {
		$i++;
		$ret .= $1;
		last if ($i >= $all);
	}
	return $ret;
}

#-----------------------------------------------------------
#  戻りボタン
#-----------------------------------------------------------
sub back_btn {
	my $mode = shift;

	print <<EOM;
<div class="backbtn">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">
<input type="submit" class="color cerulean-blue button" value="▲管理メニュー">
</form>
</div>
EOM
}

