#!/usr/bin/perl

#┌─────────────────────────────────
#│ CLIP BOARD : clip.cgi - 2019/12/01
#│ copyright (c) kentweb, 1997-2019
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  ClipBoard v6.0 : - 2019/12/06
#│  Edited by Hamel(TRANSFORM) Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;

# 設定ファイル認識
require "./init.cgi";
my %cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('容量オーバー') if ($cgi->truncated);
my %in = parse_form($cgi);

# アクセス制限
&passwd(%in) if ($cf{enter_pwd} ne '');

# 処理分岐
if ($in{mode} eq 'find') { find_data(); }
if ($in{mode} eq 'expound') { expound_page(); }
if ($in{mode} eq 'note') { note_page(); }
if ($in{mode} eq 'form') { form(); }
if ($in{mode} eq 'border') { border_page(); }
if ($in{mode} eq 'p_form') { p_form(); }
if ($in{mode} eq 'album') { album(); }
if ($in{mode} eq 'past' && $cf{pastkey}) { past_page(); }
if ($in{mode} eq 'album_past') { album_past(); }
if ($in{mode} eq 'res_album') { res_album(); }
if ($in{mode} eq 'rescom') { rescom_form(); }
if ($in{mode} eq 'res_find') { res_find_data(); }
if ($in{mode} eq 'compwd') { com_pwdform(); }
bbs_list();

#-----------------------------------------------------------
#  記事リスト画面
#-----------------------------------------------------------
sub bbs_list {
	#del_form() if ($in{del});

	# ページ数定義
	my $pg = $in{pg} || 0;

	# レスカウント
	my ($i,@log,%res_cnt,@reply,@main_log,@rescnt);
	open(IN,"$cf{rescnt}");
	while(<IN>) {
		my ($no,$date,$name,$res) = split(/<>/);

		$res_cnt{$no} = $res;

	}

	# 表示データ認識
	my ($i,@log);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while (<IN>) {
		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{pg_max});

		push(@log,$_);
	}
	close(IN);

	# ページ繰越ボタン作成
	my $pgbtn = make_btn($i,$pg);

	# クッキー取得
	my @cook = get_cookie();
	$cook[2] ||= 'http://';

	# 色選択ボタン
	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $cook[3]) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]">●</span>\n|;
	}

	# 枠色プルダウン
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	if ($cook[4] eq "") { $cook[4] = $col3[0]; }
	foreach (0 .. $#col3) {
		if ($cook[4] eq $col3[$_]) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# home or logoff
	my $home = $cf{enter_pwd} eq '' ? $cf{homepage} : "$cf{bbs_cgi}?mode=logoff";

	# カウンタ
	my $counter = bbs_count() if ($cf{counter});

	# テンプレート読み込み
	open(IN,"$cf{tmpldir}/bbs.html") or error("open err: bbs.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 文字置換
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/clip.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/clip-mobile.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!homepage!/$home/g;
	$tmpl =~ s/!page_btn!/$pgbtn/g;
	$tmpl =~ s/!reg-nam!/$cook[0]/g;
	$tmpl =~ s/!reg-eml!/$cook[1]/g;
	$tmpl =~ s/!reg-url!/$cook[2]/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!counter!/$counter/g;
	$tmpl =~ s/!color!/$color/g;
	$tmpl =~ s/<!-- op_color2 -->/$color_b/g;
	# 過去ログ
	$tmpl =~ s/<!-- past -->.+<!-- past -->//s if ($cf{pastkey} == 0);

	$tmpl =~ s/!ptop-icon!/<img src="$cf{ico_ptop}" alt="pagetop" class="icon" title="PAGE TOP" alt="">/g;


	# 画像認証作成
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain,$str_crypt) = cap::make($cf{captcha_key},$cf{cap_len});
		$tmpl =~ s/!str_crypt!/$str_crypt/g;
	} else {
		$tmpl =~ s/<!-- captcha_begin -->.+<!-- captcha_end -->//s;
	}
	
	# テンプレート分割
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3)
			: error('テンプレート不正');

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	# 表示データ展開
	foreach my $log (@log) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$ex,$w,$h,$tim,$chk,$col,$color2) = split(/<>/, $log);
		$eml = qq|<a href="mailto:$eml"><img src="$cf{ico_mail}" class="icon" alt="" /></a>| if ($eml);
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon" alt="$no$ex" /"></a>|;
		$com = auto_link($com) if ($cf{autolink});

		if (!$res_cnt{$no}) { $res_cnt{$no} = 0; }

		# YouTube
		if ($cf{tube}) {
			$com =~ s|!([\w\-]{1,})!|<span class="imageCover"><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="$cf{cmnurl}/youtube.png" width="64" height="64" class="coverImage"></a></span>|g;
		}

		# 添付あり
		if ($ex) {
			# 確認待ち
			if ($cf{imgcheck} && $chk != 1) {
				my $size = get_size("$cf{imgdir}/$no$ex");
				$com .= qq|<p>[添付]: 認証待ち ($size)</p>|;

			# 添付画像
			} elsif ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{imgdir}/$no-s$ex") {
					$op = qq|src="$cf{imgurl}/$no-s$ex"|;
				} else {
					($w,$h) = &resize($w,$h);
					$op = qq|src="$cf{imgurl}/$no$ex" width="$w" height="$h"|;
				}
				#$com .= qq|<p><a href="$cf{imgurl}/$no$ex" target="_blank"><img $op border="0"></a></p>|;

			# 画像はコメントの下
			if ($cf{imgpoint} == 1) {
				$com .= qq|<p><a class="fancybox-effects-c" href="$cf{imgurl}/$no$ex" title="$sub"><img $op border="0" class="snapshot"></a></p>|;
			# 画像はコメントの左（廻り込み）
			} else {
				$com = qq|<a class="fancybox-effects-c" href="$cf{imgurl}/$no$ex" title="$sub"><img $op border="0" align="left" hspace="18" class="snapshot"></a>$com<br clear="all">|;
			}

			# 指定アイコン (画像以外)
			} elsif (defined($cf{icons}{$ex})) {
				my $size = get_size("$cf{imgdir}/$no$ex");
				$com .= qq|<p>添付: <a href="$cf{imgurl}/$no$ex" target="_blank"><img src="$cf{icourl}/$cf{icons}{$ex}" alt="" class="icon" /></a> (<b style="color:#00a1e9">$size</b>)</p>|;
			}
		}
		# 記事書き出し
		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!email!/$eml/g;
		$tmp =~ s/!home!/$url/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
		$tmp =~ s/!color2!/$color2/g;
		$tmp =~ s|!ico_edit!|<a href="$cf{bbs_cgi}?mode=p_form&no=$no"><img src="$cf{iconurl}/Edit-02.png" alt="" /></a>|g;
		$tmp =~ s|!pin-left!|<img src="$cf{cmnurl}/pin_left01.png" border="0" alt="" class="img_a">|g;
		$tmp =~ s|!pin-right!|<img src="$cf{cmnurl}/pin_right01.png" border="0" alt="" class="img_b">|g;
		$tmp =~ s/!pg!/$pg/g;
		$tmp =~ s/!res_com!/$cf{bbs_cgi}?mode=rescom&no=$no/g;
		$tmp =~ s/!ico_com!/$cf{ico_com}/g;
		$tmp =~ s/!res_cnt!/$res_cnt{$no}/g;

	# コメント返信機能ＯＦＦ
	if ($cf{comment} == 0) {
		$tmp =~ s/<!-- rescom_job_begin -->.+<!-- rescom_job_end -->//s;
	}

		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  コメント返信フォーム
#-----------------------------------------------------------
sub rescom_form {

	# レスカウント
	my (@log,%res_cnt,@reply,$max_res_flg);
	open(IN,"$cf{rescnt}");
	while(<IN>) {
		my ($no,$date,$name,$res) = split(/<>/);

		$res_cnt{$no} = $res;

	}

	# 表示データ認識
	my (@log,@reply,%res_cnt,%res,$max_res_flg);
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	while (<IN>) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$ex,$w,$h,$tim,$chk,$col,$color2) = split(/<>/);

		if ($in{no} == $no) {
		$res{sub} = $sub;
			push(@log,$_);
		}
	}

	# コメント返信ログ
	open(IN,"$cf{reslog}");
	while(<IN>) {
		my ($no,$ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/);

		# 該当レス
		if ($in{no} == $ent) {
			push(@reply,$_);

			$res_cnt{$ent}++;
		}
	}
	close(IN);

	# クッキー取得
	my ($c_nam,$c_url) = get_cookie();
	$c_url ||= 'http://';

	# テンプレート読み込み
	open(IN,"$cf{tmpldir}/res_read.html") or error("open err: res_read.html");
	my $tmpl = join('', <IN>);
	close(IN);

	open(IN,"$cf{tmpldir}/res.html") or error("open err: res.html");
	my $resloop = join('', <IN>);
	close(IN);

	# 画像認証作成
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain,$str_crypt) = cap::make($cf{captcha_key},$cf{cap_len});
		$tmpl =~ s/!str_crypt!/$str_crypt/g;
	} else {
		$tmpl =~ s/<!-- captcha_begin -->.+<!-- captcha_end -->//s;
	}

	# テンプレート分割
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl,$resloop);

	# 文字置換
	for ($head,$foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s|!bbs_css!|$cf{cmnurl}/clip.css|g;
		s|!mob_css!|$cf{cmnurl}/clip-mobile.css|g;
		s|!form_css!|$cf{cmnurl}/form.css|g;
		s|!input_file_btn_css!|$cf{cmnurl}/input_file_btn.css|g;
		s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
		s/!c_name!/$c_nam/g;
		s/!c_url!/$c_url/g;
		s/!bbs_title!/$cf{bbs_title}/g;
		s/!max_res!/$cf{max_res}/g;
		s/!no!/$in{no}/g;
		s/!r-sub!/$res{sub}/g;
		s/!ptop-icon!/<img src="$cf{ico_ptop}" alt="pagetop">/g;

	# 返信フォームのサブミットボタン(ディスエイブル)｛エラーメッセージを表示したい場合は、コメントアウト｝
	#if ($res_cnt{$in{no}} >= $cf{max_res}) {
	#	s|<input class="submit-button" type="submit" value="Submit" />|<input class="submit-button" type="submit" value="Submit" disabled />|g;
	#	}

	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	foreach my $log (@log) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$ex,$w,$h,$tim,$chk,$col,$color2) = split(/<>/, $log);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon" alt="$no$ex" /></a>|;
		$com = auto_link($com) if ($cf{autolink});
		$eml = qq|<a href="mailto:$eml"><img src="$cf{ico_mail}" class="icon" alt="" /></a>| if ($eml);

		if (!$res_cnt{$no}) { $res_cnt{$no} = 0; }

		# YouTube
		if ($cf{tube}) {
			$com =~ s|!([\w\-]{1,})!|<span class="imageCover"><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="$cf{cmnurl}/youtube.png" width="64" height="64" class="coverImage"></a></span>|g;
		}

		# 添付あり
		if ($ex) {
			# 確認待ち
			if ($cf{imgcheck} && $chk != 1) {
				my $size = get_size("$cf{imgdir}/$no$ex");
				$com .= qq|<p>[添付]: 認証待ち ($size)</p>|;

			# 添付画像
			} elsif ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{imgdir}/$no-s$ex") {
					$op = qq|src="$cf{imgurl}/$no-s$ex"|;
				} else {
					($w,$h) = &resize($w,$h);
					$op = qq|src="$cf{imgurl}/$no$ex" width="$w" height="$h"|;
				}
				#$com .= qq|<p><a href="$cf{imgurl}/$no$ex" target="_blank"><img $op border="0"></a></p>|;

			# 画像はコメントの下
			if ($cf{imgpoint} == 1) {
				$com .= qq|<p><a class="fancybox-effects-c" href="$cf{imgurl}/$no$ex" title="$sub"><img $op border="0" class="snapshot"></a></p>|;
			# 画像はコメントの左（廻り込み）
			} else {
				$com = qq|<a class="fancybox-effects-c" href="$cf{imgurl}/$no$ex" title="$sub"><img $op border="0" align="left" hspace="18" class="snapshot"></a>$com<br clear="all">|;
			}

			# 指定アイコン (画像以外)
			} elsif (defined($cf{icons}{$ex})) {
				my $size = get_size("$cf{imgdir}/$no$ex");
				$com .= qq|<p>添付: <a href="$cf{imgurl}/$no$ex" target="_blank"><img src="$cf{icourl}/$cf{icons}{$ex}" alt="" class="icon" /></a> (<b style="color:#00a1e9">$size</b>)</p>|;
			}
		}

		my @col = split(/\s+/, $cf{colors});

		# 記事書き出し
		my $tmp = $loop;
		$tmp =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!email!/$eml/g;
		$tmp =~ s/!home!/$url/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
		$tmp =~ s/!color2!/$color2/g;
		$tmp =~ s|!ico_edit!|<a href="$cf{bbs_cgi}?mode=p_form&no=$no"><img src="$cf{iconurl}/Edit02.png" alt="" /></a>|g;
		$tmp =~ s|!pin-left!|<img src="$cf{cmnurl}/pin_left01.png" border="0" alt="" class="img_a">|g;
		$tmp =~ s|!pin-right!|<img src="$cf{cmnurl}/pin_right01.png" border="0" alt="" class="img_b">|g;
		$tmp =~ s/!res_com!/$cf{bbs_cgi}?mode=rescom&no=$no/g;
		$tmp =~ s/!ico_com!/$cf{ico_com}/g;
		$tmp =~ s|!ico_com02!|<img src="$cf{iconurl}/discuss02.png" alt="">|g;
		$tmp =~ s/!res_cnt!/$res_cnt{$no}/g;

	# 返信コメント
	if ($res_cnt{$no} == 0) {
		$tmp =~ s|<!-- rescomment -->|<span style="color:#ed6d46">《この記事にはまだコメントがありません》</span>|g;
	} else {
		$tmp =~ s/<!-- rescomment -->//g;
	}

		print $tmp;

	foreach (@reply) {
		my ($no,$ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/);
		if ($url) { $url = qq |&lt;<a href="$url" target="_blank">URL</a>&gt;|; }

		my $clip;
		# 添付あり
		if ($ex) {
			# 確認待ち
			if ($cf{imgcheck} && $chk != 1) {
				my $size = get_size("$cf{r_upldir}/$no$ex");
				$com .= qq|<p>[添付]: 認証待ち (<b style="color:#FF9966">$size</b>)</p>|;

			# 添付画像
			} elsif ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{r_upldir}/$no-s$ex") {
					$op = qq|src="$cf{r_uplurl}/$no-s$ex"|;
				} else {
					($w,$h) = resize_res($w,$h);
					$op = qq|src="$cf{r_uplurl}/$no$ex" width="$w" height="$h"|;
				}
				$clip .= qq|<div id="clip"><a href="$cf{r_uplurl}/$no$ex" class="fancybox-effects-c" title=""><img $op border="0" class="snapshot"></a></div>|;

			# 指定アイコン (画像以外)
			} elsif (defined($cf{icons}{$ex})) {
				my $size = get_size("$cf{r_upldir}/$no$ex");
				$com .= qq|<div class="clip">添付: <a href="$cf{r_uplurl}/$no$ex" target="_blank"><img src="$cf{icourl}/$cf{icons}{$ex}" alt="" class="icon" /></a> (<b style="color:#00a1e9">$size</b>)</div>|;
			}
		}

			my $tmp = $resloop;
			$tmp =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
			$tmp =~ s|!com_edit!|<a href="$cf{bbs_cgi}?mode=compwd&no=$no"><img src="$cf{iconurl}/edit03.png" alt="" class="icon" /></a>|g;
			$tmp =~ s/!r_name!/$name/g;
			$tmp =~ s/!r_date!/$date/g;
			$tmp =~ s/!r_url!/$url/g;
			$tmp =~ s/!r_comment!/$com/g;
			$tmp =~ s/<!-- ext -->/$clip/g;
			print $tmp;
		}
	}
	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  ワード検索
#-----------------------------------------------------------
sub find_data {
	# 引数取得
	$in{word} =~ s/[\r\n]//g;
	$in{cond} =~ s/\D//g;
	$in{pg} =~ s/\D//g;
	$in{pg} ||= 0;

	# 検索条件プルダウン
	my %op = (1 => 'AND', 0 => 'OR');
	my $op_cond;
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op_cond .= qq|<option value="$_" selected>$op{$_}\n|;
		} else {
			$op_cond .= qq|<option value="$_">$op{$_}\n|;
		}
	}

	# 検索実行
	my ($i,@log) = search($in{word},$in{cond}) if ($in{word} ne '');
	
	# 検索用
	my $ewd = $in{word};
	$ewd =~ s/(\W)/"%".unpack("H2",$1)/ego;
	$ewd =~ tr/ /+/;
	my $param = "&amp;mode=find&amp;word=$ewd&amp;cond=$in{cond}";

	# ページ繰越ボタン作成
	my $pgbtn = make_btn($i,$in{pg},$param);

	# テンプレート読み込み
	open(IN,"$cf{tmpldir}/find.html") or error("open err: find.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 文字置換
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/clip.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/clip-mobile.css|g;
	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/<!-- op_cond -->/$op_cond/;
	$tmpl =~ s/!word!/$in{word}/;
	$tmpl =~ s/!page_btn!/$pgbtn/;

	# テンプレート分割
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3)
			: error("テンプレート不正");

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	foreach (@log) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$ex,$w,$h,$tim,$chk,$col,$color2) = split(/<>/);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>|;
		$com = auto_link($com) if ($cf{autolink});

		my @col = split(/\s+/, $cf{colors});

		# YouTube
		if ($cf{tube}) {
			$com =~ s|!([\w\-]{1,})!|<span class="imageCover"><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="$cf{cmnurl}/youtube.png" width="64" height="64" class="coverImage"></a></span>|g;		}

		# 添付あり
		#my $clip;
		#if ($ex) {
		#	my $size = get_size("$cf{imgdir}/$no$ex");
		#	if ($cf{imgcheck} && $chk != 1) {
		#		$clip = qq|<div class="clip">[添付]: 認証待ち ($size)</div>|;
		#	} else {
		#		$clip = qq|<div class="clip">[添付]: <a class="fancybox-effects-c" href="$cf{imgurl}/$no$ex" title="$sub">$no$ex</a> ($size)</div>|;
		#	}
		#}

		my $clip;
		# 添付あり
		if ($ex) {
			# 確認待ち
			if ($cf{imgcheck} && $chk != 1) {
				my $size = get_size("$cf{imgdir}/$no$ex");
				$com .= qq|<p>[添付]: 認証待ち (<b style="color:#FF9966">$size</b>)</p>|;

			# 添付画像
			} elsif ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{imgdir}/$no-s$ex") {
					$op = qq|src="$cf{imgurl}/$no-s$ex"|;
				} else {
					($w,$h) = resize_res($w,$h);
					$op = qq|src="$cf{imgurl}/$no$ex" width="$w" height="$h"|;
				}
				$clip .= qq|<div id="clip"><a href="$cf{r_uplurl}/$no$ex" class="fancybox-effects-c" title=""><img $op border="0" class="snapshot"></a></div>|;

			# 指定アイコン (画像以外)
			} elsif (defined($cf{icons}{$ex})) {
				my $size = get_size("$cf{imgdir}/$no$ex");
				$com .= qq|<div class="clip">添付: <a href="$cf{imgurl}/$no$ex" target="_blank"><img src="$cf{icourl}/$cf{icons}{$ex}" alt="" class="icon" /></a> (<b style="color:#00a1e9">$size</b>)</div>|;
			}
		}

		# 記事書き出し
		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!url!/$url/g;
		$tmp =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
		$tmp =~ s/!color2!/$color2/g;
		$tmp =~ s/<!-- clip -->/$clip/;
		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  検索実行
#-----------------------------------------------------------
sub search {
	my ($word,$cond) = @_;

	# キーワードを配列化
	$word =~ s/\x81\x40/ /g;
	my @wd = split(/\s+/,$word);

	# UTF-8定義
	my $byte1 = '[\x00-\x7f]';
	my $byte2 = '[\xC0-\xDF][\x80-\xBF]';
	my $byte3 = '[\xE0-\xEF][\x80-\xBF]{2}';
	my $byte4 = '[\xF0-\xF7][\x80-\xBF]{3}';

	# 検索処理
	my ($i,@log);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while (<IN>) {
		my ($no,$date,$nam,$eml,$sub,$com,$url,$host,$pw,$ex,$w,$h,$tim,$chk,$col,$color2) = split(/<>/);

		my $flg;
		foreach my $wd (@wd) {
			if ("$nam $eml $sub $com $url" =~ /^(?:$byte1|$byte2|$byte3|$byte4)*?\Q$wd\E/i) {
				$flg++;
				if ($cond == 0) { last; }
			} else {
				if ($cond == 1) { $flg = 0; last; }
			}
		}
		next if (!$flg);

		$i++;
		next if ($i < $in{pg} + 1);
		next if ($i > $in{pg} + $cf{pg_max});
		
		push(@log,$_);
	}
	close(IN);

	# 検索結果
	return ($i,@log);
}

#-----------------------------------------------------------
#  コメントワード検索
#-----------------------------------------------------------
sub res_find_data {
	# 引数取得
	$in{word} =~ s/[\r\n]//g;
	$in{cond} =~ s/\D//g;
	$in{pg} =~ s/\D//g;
	$in{pg} ||= 0;

	# 検索条件プルダウン
	my %op = (1 => 'AND', 0 => 'OR');
	my $op_cond;
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op_cond .= qq|<option value="$_" selected>$op{$_}\n|;
		} else {
			$op_cond .= qq|<option value="$_">$op{$_}\n|;
		}
	}

	# 検索実行
	my ($i,@reply) = res_search($in{word},$in{cond}) if ($in{word} ne '');
	
	# 検索用
	my $ewd = $in{word};
	$ewd =~ s/(\W)/"%".unpack("H2",$1)/ego;
	$ewd =~ tr/ /+/;
	my $param = "&amp;mode=res_find&amp;word=$ewd&amp;cond=$in{cond}";

	# ページ繰越ボタン作成
	my $pgbtn = make_resbtn($i,$in{pg},$param);

	# テンプレート読み込み
	open(IN,"$cf{tmpldir}/res_find.html") or error("open err: res_find.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# テンプレート分割
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3) : error("テンプレート不正");

	# 文字置換
	for ($head,$foot) {
		s|!bbs_css!|$cf{cmnurl}/clip.css|g;
		s|!mob_css!|$cf{cmnurl}/clip-mobile.css|g;
		s/!bbs_cgi!/$cf{bbs_cgi}/g;
		s/!bbs_title!/$cf{bbs_title}/g;
		s/<!-- op_cond -->/$op_cond/;
		s/!word!/$in{word}/;
		s/!page_btn!/$pgbtn/;
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	foreach (@reply) {
		my ($no,$ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/);
		if ($url) { $url = qq |&lt;<a href="$url" target="_blank">URL</a>&gt;|; }

		# 添付あり
		#my $clip;
		#if ($ex) {
		#	my $size = get_size("$cf{r_upldir}/$no$ex");
		#	if ($cf{imgcheck} && $chk != 1) {
		#		$clip = qq|<div class="clip">[添付]: 認証待ち ($size)</div>|;
		#	} else {
		#		$clip = qq|<div class="clip">[添付]: <a href="$cf{r_uplurl}/$no$ex" target="_blank">$no$ex</a> ($size)</div>|;
		#	}
		#}

		my $clip;
		# 添付あり
		if ($ex) {
			# 確認待ち
			if ($cf{imgcheck} && $chk != 1) {
				my $size = get_size("$cf{r_upldir}/$no$ex");
				$com .= qq|<p>[添付]: 認証待ち (<b style="color:#FF9966">$size</b>)</p>|;

			# 添付画像
			} elsif ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{r_upldir}/$no-s$ex") {
					$op = qq|src="$cf{r_uplurl}/$no-s$ex"|;
				} else {
					($w,$h) = resize_res($w,$h);
					$op = qq|src="$cf{r_uplurl}/$no$ex" width="$w" height="$h"|;
				}
				$clip .= qq|<div id="clip"><a href="$cf{r_uplurl}/$no$ex" class="fancybox-effects-c" title=""><img $op border="0" class="snapshot"></a></div>|;

			# 指定アイコン (画像以外)
			} elsif (defined($cf{icons}{$ex})) {
				my $size = get_size("$cf{r_upldir}/$no$ex");
				$com .= qq|<div class="clip">添付: <a href="$cf{r_uplurl}/$no$ex" target="_blank"><img src="$cf{icourl}/$cf{icons}{$ex}" alt="" class="icon" /></a> (<b style="color:#00a1e9">$size</b>)</div>|;
			}
		}

		# 記事書き出し
		my $tmp = $loop;
		$tmp =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
		$tmp =~ s|!com_edit!|<a href="$cf{bbs_cgi}?mode=compwd&no=$no"><img src="$cf{iconurl}/edit03.png" alt="" class="icon" /></a>|g;
		$tmp =~ s/!r_num!/$no/g;
		$tmp =~ s/!r_name!/$name/g;
		$tmp =~ s/!r_date!/$date/g;
		$tmp =~ s/!r_url!/$url/g;
		$tmp =~ s/!r_comment!/$com/g;
		$tmp =~ s/<!-- ext -->/$clip/g;
		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  コメント検索実行
#-----------------------------------------------------------
sub res_search {
	my ($word,$cond) = @_;

	# キーワードを配列化
	$word =~ s/\x81\x40/ /g;
	my @wd = split(/\s+/,$word);

	# UTF-8定義
	my $byte1 = '[\x00-\x7f]';
	my $byte2 = '[\xC0-\xDF][\x80-\xBF]';
	my $byte3 = '[\xE0-\xEF][\x80-\xBF]{2}';
	my $byte4 = '[\xF0-\xF7][\x80-\xBF]{3}';

	# 検索処理
	my ($i,@reply);
	open(IN,"$cf{reslog}") or error("open err: $cf{logfile}");
	while (<IN>) {
		my ($no,$ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/);

		my $flg;
		foreach my $wd (@wd) {
			if ("$date $name $url $com" =~ /^(?:$byte1|$byte2|$byte3|$byte4)*?\Q$wd\E/i) {
				$flg++;
				if ($cond == 0) { last; }
			} else {
				if ($cond == 1) { $flg = 0; last; }
			}
		}
		next if (!$flg);

		$i++;
		next if ($i < $in{pg} + 1);
		next if ($i > $in{pg} + $cf{max_resfind});
		
		push(@reply,$_);
	}
	close(IN);

	# 検索結果
	return ($i,@reply);
}

#-----------------------------------------------------------
#  アルバム機能
#-----------------------------------------------------------
sub album {
	# ページ数定義
	my $pg = $in{pg} || 0;

	# 画像サイズ再定義
	$cf{max_img_w} = $cf{alb_img_w};
	$cf{max_img_h} = $cf{alb_img_h};

	# テンプレート認識
	open(IN,"$cf{tmpldir}/album.html") or error("open err: album.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# テンプレート分割
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	# データ読み込み
	my ($i,@img);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while (<IN>) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$ex,$w,$h,$tim,$chk,$col,$color2) = split(/<>/);
		next if ($cf{imgcheck} && $chk eq '0');
		next if ($ex !~ /(jpg|png|gif)$/);

		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{max_albums});

		# 画像データ収集
		push(@img,"$no\t$sub\t$ex\t$w\t$h");
	}
	close(IN);

	# 繰越ボタン
	my $page_btn = make_pgbtn($i,$pg,'&mode=album',$cf{max_albums});

	# 文字置換
	for ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!bbs_title!/$cf{bbs_title}/g;
		s|!bbs_css!|$cf{cmnurl}/clip.css|g;
		s|!mob_css!|$cf{cmnurl}/clip-mobile.css|g;
		s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
		s/!page_btn!/$page_btn/g;
	# 過去ログ
		s/<!-- past -->.+<!-- past -->//s if ($cf{pastkey} == 0);
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	foreach (@img) {
		my ($no,$sub,$ex,$w,$h) = split(/\t/);

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!image!/image($no,$sub,$ex,$w,$h)/eg;
		$tmp =~ s/!caption!/$sub/g;
		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  アルバム機能 (過去ログ)
#-----------------------------------------------------------
sub album_past {
	# ページ数定義
	my $pg = $in{pg} || 0;

	# 画像サイズ再定義
	$cf{max_img_w} = $cf{alb_img_w};
	$cf{max_img_h} = $cf{alb_img_h};

	# テンプレート認識
	open(IN,"$cf{tmpldir}/album_past.html") or error("open err: album_past.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# テンプレート分割
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	# 過去ログ番号
	open(IN,"$cf{nofile}") or error("open err: $cf{nofile}");
	my $pastnum = <IN>;
	close(IN);

	my $pastnum = sprintf("%04d", $pastnum);
	$in{pno} =~ s/\D//g;
	$in{pno} ||= $pastnum;

	# 対象ログ定義
	my $file = "$cf{pastdir}/" . sprintf("%04d", $in{pno}) . ".cgi";

	# データ読み込み
	my ($i,@img);
	open(IN,"$file") or error("open err: $file");
	while (<IN>) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$ex,$w,$h,$tim,$chk,$col,$color2) = split(/<>/);
		next if ($cf{imgcheck} && $chk eq '0');
		next if ($ex !~ /(jpg|png|gif)$/);

		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{max_albums});

		# 画像データ収集
		push(@img,"$no\t$sub\t$ex\t$w\t$h");
	}
	close(IN);

	# 繰越ボタン
	my $page_btn = make_pgbtn($i,$pg,'&mode=album_past',$cf{max_albums});

	# 文字置換
	for ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!bbs_title!/$cf{bbs_title}/g;
		s|!bbs_css!|$cf{cmnurl}/clip.css|g;
		s|!mob_css!|$cf{cmnurl}/clip-mobile.css|g;
		s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
		s/!page_btn!/$page_btn/g;
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	foreach (@img) {
		my ($no,$sub,$ex,$w,$h) = split(/\t/);

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!image!/image($no,$sub,$ex,$w,$h)/eg;
		$tmp =~ s/!caption!/$sub/g;
		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  コメント返信アルバム機能
#-----------------------------------------------------------
sub res_album {
	# ページ数定義
	my $pg = $in{pg} || 0;

	# 画像サイズ再定義
	$cf{max_img_w} = $cf{r_max_img_w};
	$cf{max_img_h} = $cf{r_max_img_h};

	# テンプレート認識
	open(IN,"$cf{tmpldir}/res_album.html") or error("open err: res_album.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# テンプレート分割
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	# データ読み込み
	my ($i,@img);
	open(IN,"$cf{reslog}") or error("open err: $cf{reslog}");
	while (<IN>) {
		my ($no,$ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/);
		next if ($cf{imgcheck} && $chk eq '0');
		next if ($ex !~ /(jpg|png|gif)$/);

		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{max_resalbum});

		# 画像データ収集
		push(@img,"$no\t$ent\t$ex\t$w\t$h");
	}
	close(IN);

	# 繰越ボタン
	my $page_btn = make_pgbtn($i,$pg,'&mode=res_album',$cf{max_resalbum});

	# 文字置換
	for ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!bbs_title!/$cf{bbs_title}/g;
		s/!page_btn!/$page_btn/g;
		s|!bbs_css!|$cf{cmnurl}/clip.css|g;
		s|!mob_css!|$cf{cmnurl}/clip-mobile.css|g;
	# 過去ログ
		s/<!-- past -->.+<!-- past -->//s if ($cf{pastkey} == 0);
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	foreach (@img) {
		my ($no,$ent,$ex,$w,$h) = split(/\t/);

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!ent!/$ent/g;
		$tmp =~ s/!res-image!/res_image($no,$ent,$ex,$w,$h)/eg;
		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  過去ログページ
#-----------------------------------------------------------
sub past_page {
	# 過去ログ番号
	open(IN,"$cf{nofile}") or error("open err: $cf{nofile}");
	my $pastnum = <IN>;
	close(IN);

	my $pastnum = sprintf("%04d",$pastnum);
	$in{pno} =~ s/\D//g;
	$in{pno} ||= $pastnum;

	# プルダウンタグ作成
	my $op_pno;
	for ( my $i = $pastnum; $i > 0; $i-- ) {
		$i = sprintf("%04d",$i);

		if ($in{pno} == $i) {
			$op_pno .= qq|<option value="$i" selected="selected">$i</option>\n|;
		} else {
			$op_pno .= qq|<option value="$i">$i</option>\n|;
		}
	}

	# ページ数
	my $pg = $in{pg} || 0;

	# 初期化
	my ($hit,$page_btn,@log);

	# 対象ログ定義
	my $file = "$cf{pastdir}/" . sprintf("%04d", $in{pno}) . ".cgi";

	# ワード検索
	if ($in{find} && $in{word} ne '') {

		# 検索
		($hit,@log) = search($file,$in{list},'past');

		# 結果
		$page_btn = "検索結果：<b>$hit</b>件 &nbsp;&nbsp;" . pgbtn_old($hit,$in{pno},$pg,$in{list},'find');

	# ログ一覧
	} else {

		# 過去ログオープン
		my $i = 0;
		open(IN,"$file") or error("open err: $file");
		while(<IN>) {
			$i++;
			next if ($i < $pg + 1);
			next if ($i > $pg + $cf{pg_maxp} );

			push(@log,$_);
		}
		close(IN);

		# 繰越ボタン作成
		$page_btn = pgbtn_old($i,$in{pno},$pg);
	}

	# プルダウン作成（検索条件）
	my %op = make_op();

	# テンプレート読み込み
	open(IN,"$cf{tmpldir}/past.html") or error("open err: past.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# テンプレート分割
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	if ($in{change}) { $in{word} = ''; }

	my @col = split(/\s+/,$cf{colors});

	# 文字置換
	for ($head, $foot) {
		s/!past_num!/$in{pno}/g;
		s/!bbs_url!//g;
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!bbs_title!/$cf{bbs_title}/g;
		s|!bbs_css!|$cf{cmnurl}/clip.css|g;
		s|!mob_css!|$cf{cmnurl}/clip-mobile.css|g;
		s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
		s/<!-- op_pno -->/$op_pno/g;
		s/<!-- op_(\w+) -->/$op{$1}/g;
		s/!word!/$in{word}/g;
		s/!page_btn!/$page_btn/g;
	}

	# 画面表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	foreach (@log) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$ex,$w,$h,$tim,$chk,$col,$color2) = split(/<>/);
		$eml = qq|<a href="mailto:$eml"><img src="$cf{ico_mail}" class="icon"></a>| if ($eml);
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>|;
		$com = auto_link($com) if ($cf{autolink});

		# YouTube
		if ($cf{tube}) {
			$com =~ s|!([\w\-]{1,})!|<span class="imageCover"><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="$cf{cmnurl}/youtube.png" width="64" height="64" class="coverImage"></a></span>|g;		}

		# 添付あり
		if ($ex) {
			# 確認待ち
			if ($cf{imgcheck} && $chk != 1) {
				my $size = get_size("$cf{imgdir}/$no$ex");
				$com .= qq|<p>[添付]: 認証待ち ($size)</p>|;

			# 添付画像
			} elsif ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{imgdir}/$no-s$ex") {
					$op = qq|src="$cf{imgurl}/$no-s$ex"|;
				} else {
					($w,$h) = &resize($w,$h);
					$op = qq|src="$cf{imgurl}/$no$ex" width="$w" height="$h"|;
				}
				#$com .= qq|<p><a href="$cf{imgurl}/$no$ex" target="_blank"><img $op border="0"></a></p>|;

			# 画像はコメントの下
			if ($cf{imgpoint} == 1) {
				$com .= qq|<p><a class="fancybox-effects-c" href="$cf{imgurl}/$no$ex" title="$sub"><img $op border="0" class="snapshot"></a></p>|;
			# 画像はコメントの左（廻り込み）
			} else {
				$com = qq|<a class="fancybox-effects-c" href="$cf{imgurl}/$no$ex" title="$sub"><img $op border="0" align="left" hspace="18" class="snapshot"></a>$com<br clear="all">|;
			}

			# 画像以外
			} else {
				my $size = get_size("$cf{imgdir}/$no$ex");
				$com .= qq|<p>添付: <a href="$cf{imgurl}/$no$ex" target="_blank"><img src="$cf{ico_clip}" class="clip"></a> ($size)</p>|;
			}
		}

		# 記事書き出し
		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!email!/$eml/g;
		$tmp =~ s/!home!/$url/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
		$tmp =~ s/!color2!/$color2/g;
		print $tmp;
	}

	# フッタ
	footer($foot);
	exit;
}

#-----------------------------------------------------------
#  プルダウン作成 [ 検索条件 ]
#-----------------------------------------------------------
sub make_op {
	my %op;
	my %cond = (1 => 'AND', 0 => 'OR');
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op{cond} .= qq|<option value="$_" selected>$cond{$_}\n|;
		} else {
			$op{cond} .= qq|<option value="$_">$cond{$_}\n|;
		}
	}
	for ( my $i = 10; $i <= 30; $i += 5 ) {
		if ($in{list} == $i) {
			$op{list} .= qq|<option value="$i" selected>$i件\n|;
		} else {
			$op{list} .= qq|<option value="$i">$i件\n|;
		}
	}
	return %op;
}

#-----------------------------------------------------------
#  繰越ボタン作成 (アルバム)
#-----------------------------------------------------------
sub make_pgbtn {
	my ($i,$pg,$stat,$max) = @_;
	$max ||= 5;

	# ページ繰越定義
	my $next = $pg + $max;
	my $back = $pg - $max;

	# ページ繰越ボタン作成
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>!);
			} else {
				push(@pg,qq!<li><a href="$cf{bbs_cgi}?pg=$y$stat">$x</a></li>!);
			}
			$x++;
			$y += $max;
			$z -= $max;

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$cf{bbs_cgi}?pg=$back$stat">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$cf{bbs_cgi}?pg=$next$stat">&raquo;</a></li>\n!;
	}
	# 結果を返す
	return $ret ? qq|<ul class="pager">$ret</ul>| : '';
}

#-----------------------------------------------------------
#  留意事項表示
#-----------------------------------------------------------
sub note_page {
	# 許可拡張子（表示用）
	my $ftype = ext_file();

	open(IN,"$cf{tmpldir}/note.html") or error("open err: note.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!filetype!/$ftype/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/clip.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/clip-mobile.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  YouTube貼付方法
#-----------------------------------------------------------
sub expound_page {

	open(IN,"$cf{tmpldir}/expound.html  ") or error("open err: expound.html  ");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/clip.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  投稿フォーム
#-----------------------------------------------------------
sub form {
	&passwd2(%in) if ($cf{usr_password} ne '');

	# クッキー取得
	my @cook = get_cookie();
	$cook[2] ||= 'http://';

	# 色選択ボタン
	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $cook[3]) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]">●</span>\n|;
	}

	# 枠色プルダウン
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	if ($cook[4] eq "") { $cook[4] = $col3[0]; }
	foreach (0 .. $#col3) {
		if ($cook[4] eq $col3[$_]) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# 画像認証作成
	my ($str_plain,$str_crypt,$regikey,$JavaScript);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain, $str_crypt, $regikey, $JavaScript) = cap::make( $cf{captcha_key}, $cf{cap_len} );
		$JavaScript=&mkJavaScript($regikey,'myFORM') if($cf{cap_len} == 3);
	}

	open(IN,"$cf{tmpldir}/form.html") or &error("open err: form.html");
	print "Content-type: text/html; charset=utf-8\n\n";
	while(<IN>) {

	# 文字置換
		s/!str_crypt!/$str_crypt/g;
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!homepage!/$cf{homepage}/g;
		s/!name!/$cook[0]/g;
		s/!email!/$cook[1]/g;
		s/!url!/$cook[2]/g;
		s/!color!/$color/g;
		s/<!-- op_color2 -->/$color_b/g;
		s/!bbs_title!/$cf{bbs_title}/g;
		s|!bbs_css!|$cf{cmnurl}/clip.css|g;
		s|!mob_css!|$cf{cmnurl}/clip-mobile.css|g;
		s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
		s/!JavaScript!/$JavaScript/g;
		print;
	}
	close(IN);
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  パスワードフォーム
#-----------------------------------------------------------
sub p_form {

	$in{no} =~ s/\D//g;

	# クッキー取得
	my @cook = get_cookie();
	$cook[2] ||= 'http://';

	# 記事
	my ($name,$pwd);
	open(DAT,"+< $cf{logfile}") || &error("Open Error: $cf{logfile}");
	eval "flock(DAT, 2);";
	while (<DAT>) {
		my ($no,$date,$nam,$eml,$sub,$com,$url,$host,$pw,$ex,$w,$h,$tim,$chk,$col,$color2) = split(/<>/);

	if ($in{no} == $no) {
		$name = $nam;
		$sub = $sub;
		$pwd = $pw;
		last;
		}
	}
	close(DAT);

	# パスワード未設定
	&error("この記事はパスワード未設定のため編集できません") if ($pwd eq '');

	my ($no,$date,$nam,$eml,$sub,$com,$url,$host,$pw,$ex,$w,$h,$tim,$chk,$col,$color2) = split(/<>/);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>|;
		$com = auto_link($com) if ($cf{autolink});
		if (length($com) > 135) { $com = substr($com,0,140); $com .= '.....(略)'; }

		# 添付あり
		if ($ex) {
			# 確認待ち
			if ($cf{imgcheck} && $chk != 1) {
				my $size = get_size("$cf{imgdir}/$no$ex");
				$com .= qq|<p>[添付]: 認証待ち ($size)</p>|;

			# 添付画像
			} elsif ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{imgdir}/$no-s$ex") {
					$op = qq|src="$cf{imgurl}/$no-s$ex"|;
				} else {
					($w,$h) = &resize($w,$h);
					$op = qq|src="$cf{imgurl}/$no$ex" width="$w" height="$h"|;
				}
			# 画像はコメントの下
			if ($cf{imgpoint} == 1) {
				$com .= qq|<p><a href="$cf{imgurl}/$no$ex" class="fancybox-effects-c"><img $op border="0"></a></p>|;
			# 画像はコメントの左（廻り込み）
			} else {
				$com = qq|<a href="$cf{imgurl}/$no$ex" class="fancybox-effects-c"><img $op border="0" align="left" hspace="12"></a>$com<br clear="all">|;
			}

			# 指定アイコン (画像以外)
			} elsif (defined($cf{icons}{$ex})) {
				my $size = get_size("$cf{imgdir}/$no$ex");
				$com .= qq|<div class="clip">添付: <a href="$cf{imgurl}/$no$ex" target="_blank"><img src="$cf{icourl}/$cf{icons}{$ex}" alt="" class="icon" /></a> (<b style="color:#00a1e9">$size</b>)</div>|;
			}
		}

	my @col = split(/\s+/, $cf{colors});

	open(IN,"$cf{tmpldir}/p_form.html") or &error("open err: p_form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 文字置換
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!name!/$name/g;
	$tmpl =~ s/!no!/$in{no}/g;
	$tmpl =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
	$tmpl =~ s/!date!/$date/g;
	$tmpl =~ s/!url!/$url/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/clip.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/clip-mobile.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!num!/$no/g;
	$tmpl =~ s/!pwd!/$pw/g;
	$tmpl =~ s/!color2!/$color2/g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  コメント返信パスワードフォーム
#-----------------------------------------------------------
sub com_pwdform {

	$in{no} =~ s/\D//g;

	# クッキー取得
	my @cook = get_cookie();
	$cook[2] ||= 'http://';

	# 記事
	my ($name,$pwd);
	open(DAT,"+< $cf{reslog}") || &error("Open Error: $cf{reslog}");
	eval "flock(DAT, 2);";
	while (<DAT>) {
		my ($no,$ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/);

	if ($in{no} == $no) {
		$name = $name;
		$sub = $sub;
		$pwd = $pw;
		last;
		}
	}
	close(DAT);

	# パスワード未設定
	&error("このコメントはパスワード未設定のため編集できません") if ($pwd eq '');

	my ($no,$ent,$sub,$date,$name,$url,$host,$com,$ex,$w,$h,$chk,$pw) = split(/<>/);
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>|;
		$com = auto_link($com) if ($cf{autolink});
		if (length($com) > 110) { $com = substr($com,0,120); $com .= '.....(略)'; }

		# 添付あり
		if ($ex) {
			# 確認待ち
			if ($cf{imgcheck} && $chk != 1) {
				my $size = get_size("$cf{r_upldir}/$no$ex");
				$com .= qq|<p>[添付]: 認証待ち ($size)</p>|;

			# 添付画像
			} elsif ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{r_upldir}/$no-s$ex") {
					$op = qq|src="$cf{r_uplurl}/$no-s$ex"|;
				} else {
					($w,$h) = &resize($w,$h);
					$op = qq|src="$cf{r_uplurl}/$no$ex" width="$w" height="$h"|;
				}
		# 画像はコメントの下
		if ($cf{imgpoint} == 1) {
			$com .= qq|<p><a href="$cf{r_uplurl}/$no$ex" class="fancybox-effects-c"><img $op border="0"></a></p>|;
		# 画像はコメントの左（廻り込み）
		} else {
			$com = qq|<a href="$cf{r_uplurl}/$no$ex" class="fancybox-effects-c"><img $op border="0" align="left" hspace="12"></a>$com<br clear="all">|;
		}

		# 指定アイコン (画像以外)
		} elsif (defined($cf{icons}{$ex})) {
			my $size = get_size("$cf{r_upldir}/$no$ex");
			$com .= qq|<div class="clip">添付: <a href="$cf{r_uplurl}/$no$ex" target="_blank"><img src="$cf{icourl}/$cf{icons}{$ex}" alt="" class="icon" /></a> (<b style="color:#00a1e9">$size</b>)</div>|;
		}
		}

	my @col = split(/\s+/, $cf{colors});

	open(IN,"$cf{tmpldir}/res_pwdform.html") or &error("open err: res_pwdform.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 文字置換
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!name!/$name/g;
	$tmpl =~ s/!no!/$in{no}/g;
	$tmpl =~ s|!comment!|$com|g;
	$tmpl =~ s/!date!/$date/g;
	$tmpl =~ s/!url!/$url/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/clip.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/clip-mobile.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!num!/$no/g;
	$tmpl =~ s/!pwd!/$pwd/g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  ボーダーカラー・サンプル
#-----------------------------------------------------------
sub border_page {

	# テンプレート認識
	open(IN,"$cf{tmpldir}/border_color.html") or &error("open err: border_color.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# テンプレート分割
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1, $2, $3);
	} else {
		&error("テンプレートが不正です");
	}

	# 文字置換
	foreach ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!version!/$cf{version}/g;
		s|!bbs_css!|$cf{cmnurl}/clip.css|g;
		s|!mob_css!|$cf{cmnurl}/clip-mobile.css|g;
		s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	foreach (0 .. $#col3) {

		my $tmp = $loop;
		$tmp =~ s/!name!/$col4[$_]/g;
		$tmp =~ s|!color_b!|<div class="bubble2" style="border-color:$col3[$_]"><div class="rectangle2" style="background:$col3[$_]; background-image: linear-gradient(to bottom,transparent 8%, rgba(255, 255, 255, 0.5) 8%, rgba(255, 255, 255, 0.5) 12%, transparent 12%, transparent 88%, rgba(255, 255, 255, 0.5) 88%, rgba(255, 255, 255, 0.5) 92%, transparent 92%);"><h2>3D CSS Ribbon</h2></div><div class="triangle2-l" style="border-color: transparent $col3[$_] transparent transparent;"></div><div class="triangle2-r" style="border-color: transparent transparent transparent $col3[$_];"></div><div class="info2"><h2>$col4[$_]</h2></div></div>|g;
		print $tmp;
	}

	# フッタ
	footer($foot);
	exit;
}

#-----------------------------------------------------------
#  カウンタ処理
#-----------------------------------------------------------
sub bbs_count {
	# IP取得
	my $addr = $ENV{REMOTE_ADDR};

	# 閲覧時のみカウントアップ
	my $cntup = $in{mode} eq '' ? 1 : 0;

	# カウントファイルを読みこみ
	open(LOG,"+< $cf{cntfile}") or error("open err: $cf{cntfile}");
	eval "flock(LOG, 2);";
	my $count = <LOG>;

	# IPチェックとログ破損チェック
	my ($cnt,$ip) = split(/:/,$count);
	if ($addr eq $ip or $cnt eq "") { $cntup = 0; }

	# カウントアップ
	if ($cntup) {
		$cnt++;
		seek(LOG, 0, 0);
		print LOG "$cnt:$addr";
		truncate(LOG, tell(LOG));
	}
	close(LOG);

	# 桁数調整
	while(length($cnt) < $cf{mini_fig}) { $cnt = '0' . $cnt; }
	my @cnts = split(//,$cnt);

	# GIFカウンタ表示
	my $counter;
	if ($cf{counter} == 2) {
		foreach (0 .. $#cnts) {
			$counter .= qq|<img src="$cf{gif_path}/$cnts[$_].gif\" alt="$cnts[$_]" />|;
		}

	# テキストカウンタ表示
	} else {
		$counter = qq|<span style="color:$cf{cntcol}">$cnt</span>\n|;
	}
	return $counter;
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<p style="margin-top:2em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:10.5pt;">
- <a href="https://www.kent-web.com/" target="_top">$cf{version}</a> -<br />
++ <a href="https://www.transformsite.com/" target="_top">Edited by Hamel</a> ++
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  自動リンク
#-----------------------------------------------------------
sub auto_link {
	my $text = shift;

	$text =~ s/(s?https?:\/\/([\w-.!~*'();\/?:\@=+\$,%#]|&amp;)+)/<a href="$1" target="_blank">$1<\/a>/g;
	return $text;
}

#-----------------------------------------------------------
#  クッキー取得
#-----------------------------------------------------------
sub get_cookie {
	# クッキー取得
	$ENV{HTTP_COOKIE} =~ /$cf{cookie_id}=(.+);?/;
	my $cookie = $1;

	# URLデコード
	my @cook;
	foreach ( split(/<>/,$cookie) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  取り扱いファイル
#-----------------------------------------------------------
sub ext_file {
	my $ext;
	foreach ( keys %cf ) {
		next if ($_ !~ /^ok_(\w+)/);
		my $file = $1;
		next if (!$cf{$_});

		$file =~ tr/a-z/A-Z/;
		$ext .= "$file, ";
	}
	$ext =~ s/, $//;

	return $ext;
}

#-----------------------------------------------------------
#  画像表示(アルバム)
#-----------------------------------------------------------
sub image {
	my ($no,$sub,$ex,$w,$h) = @_;

	my $image;
	if (-f "$cf{imgdir}/$no-s$ex") {
		$image = qq|<img src="$cf{imgdir}/$no-s$ex" border="0">|;

	} else {
		($w,$h) = resize($w,$h);
		$image = qq|<img src="$cf{imgdir}/$no$ex" width="$w" height="$h" border="0">|;
	}
	return qq|<a class="fancybox-buttons" data-fancybox-group="button" href="$cf{imgdir}/$no$ex" title="$sub">$image</a>\n|;
}

#-----------------------------------------------------------
#  コメント返信画像表示(アルバム)
#-----------------------------------------------------------
sub res_image {
	my ($no,$ent,$ex,$w,$h) = @_;

	my $image;
	if (-f "$cf{r_upldir}/$no-s$ex") {
		$image = qq|<img src="$cf{r_upldir}/$no-s$ex" border="0">|;

	} else {
		($w,$h) = resize($w,$h);
		$image = qq|<img src="$cf{r_upldir}/$no$ex" width="$w" height="$h" border="0">|;
	}
	return qq|<a class="fancybox-buttons" data-fancybox-group="button" href="$cf{r_upldir}/$no$ex" title="">$image</a>\n|;
}

#-----------------------------------------------------------
#  繰越ボタン作成 [ 過去ログ ]
#-----------------------------------------------------------
sub pgbtn_old {
	my ($i,$pno,$pg,$stat) = @_;

	# ページ繰越定義
	$cf{pg_maxp} ||= 10;
	my $next = $pg + $cf{pg_maxp} ;
	my $back = $pg - $cf{pg_maxp} ;

	my $link;
	if ($stat eq 'past') {
		my $wd = url_enc($in{word});
		$link = "$cf{bbs_cgi}?mode=$in{mode}&amp;pno=$pno&amp;find=1&amp;word=$wd";
	} else {
		$link = "$cf{bbs_cgi}?mode=$in{mode}&amp;pno=$pno";
	}

	# ページ繰越ボタン作成
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>\n!);
			} else {
				push(@pg,qq!<li><a href="$link&amp;pg=$y">$x</a></li>\n!);
			}
			$x++;
			$y += $cf{pg_maxp} ;
			$z -= $cf{pg_maxp} ;
			
			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$link&amp;pg=$back">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$link&amp;pg=$next">&raquo;</a></li>\n!;
	}
	
	# 結果を返す
	return $ret ? qq|<ul class="pager">\n$ret</ul>| : '';
}

#-----------------------------------------------------------
#  繰越ボタン作成
#-----------------------------------------------------------
sub make_btn {
	my ($i,$pg,$param) = @_;

	# ページ繰越数定義
	$cf{pg_max} ||= 10;
	my $next = $pg + $cf{pg_max};
	my $back = $pg - $cf{pg_max};

	# ページ繰越ボタン作成
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>!);
			} else {
				push(@pg,qq!<li><a href="$cf{bbs_cgi}?pg=$y$param">$x</a></li>!);
			}
			$x++;
			$y += $cf{pg_max};
			$z -= $cf{pg_max};

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$cf{bbs_cgi}?pg=$back$param">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$cf{bbs_cgi}?pg=$next$param">&raquo;</a></li>\n!;
	}
	
	# 結果を返す
	return $ret ? qq|<ul class="pager">\n$ret</ul>| : '';
}

#-----------------------------------------------------------
#  コメント繰越ボタン作成
#-----------------------------------------------------------
sub make_resbtn {
	my ($i,$pg,$param) = @_;

	# ページ繰越数定義
	$cf{max_resfind} ||= 10;
	my $next = $pg + $cf{max_resfind};
	my $back = $pg - $cf{max_resfind};

	# ページ繰越ボタン作成
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>!);
			} else {
				push(@pg,qq!<li><a href="$cf{bbs_cgi}?pg=$y$param">$x</a></li>!);
			}
			$x++;
			$y += $cf{max_resfind};
			$z -= $cf{max_resfind};

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$cf{bbs_cgi}?pg=$back$param">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$cf{bbs_cgi}?pg=$next$param">&raquo;</a></li>\n!;
	}
	
	# 結果を返す
	return $ret ? qq|<ul class="pager">\n$ret</ul>| : '';
}

#-----------------------------------------------------------
#  ファイル容量
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024000 ? comma(int($size/1024000)) . 'MB' : $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  桁区切り
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

#-----------------------------------------------------------
#  記事削除確認
#-----------------------------------------------------------
#sub del_form {
#	my %log;
#	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
#	while (<IN>) {
#		my ($no,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$ex,$w,$h,$tim,$chk) = split(/<>/);
#		if ($in{del} == $no) {
#			$log{flg}++;
#			$log{num}  = $no;
#			$log{sub}  = $sub;
#			$log{date} = $date;
#			$log{name} = $nam;
#			last;
#		}
#	}
#	close(IN);
	
#	if (!$log{flg}) { error("該当記事が見つかりません"); }
	
#	open(IN,"$cf{tmpldir}/dele.html") or error("open err: dele.html");
#	my $tmpl = join('', <IN>);
#	close(IN);
	
#	my $pg = $in{pg} || 0;
#	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
#	$tmpl =~ s/!(\w+_\w+)!/$cf{$1}/g;
#	$tmpl =~ s/!(sub|name|date|num)!/$log{$1}/g;
#	$tmpl =~ s/!pg!/$pg/g;
#	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	
#	print "Content-type: text/html; charset=shift_jis\n\n";
#	print $tmpl;
#	exit;
#}

